de154710fdc8e95ce726eac82a2f992e76ef8378
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/sh
2 # Filename:      grml-bootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see http://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2.
7 # Latest change: Mon Apr 16 20:39:13 CEST 2007 [mika]
8 ################################################################################
9 # http://www.debian.org/releases/stable/i386/index.html.en
10
11 set -e # exit on any error
12
13 VERSION='0.9'
14
15 # source core functions {{{
16 . /etc/grml/lsb-functions
17 . /etc/grml/script-functions
18 # }}}
19
20 # make sure we have what we need {{{
21 check4progs debootstrap || exit 1
22 check4root || exit 1
23 # }}}
24
25 # without config file it won't work {{{
26 if [ -r /etc/debootstrap/config ] ; then
27    . /etc/debootstrap/config
28 else
29    eerror "/etc/debootstrap/config could not be read, exiting." ; eend 1
30    exit 1
31 fi
32 # }}}
33
34 # cmdline handling {{{
35 usage() {
36   einfo "$0 - version $VERSION"
37   echo  "   A wrapper around debootstrap for installing plain Debian via grml"
38   echo
39   einfo "Usage: $0 [options]"
40   echo  "   Adjust /etc/debootstrap/config and invoke $0 afterwards or use the cmdline option:"
41   echo
42   einfo "Valid options:"
43   echo  "
44     -h|--help                   Print this usage information and exit.
45     -v|--version                Show summary of options and exit.
46
47     -t|--target <target>        Target partition (/dev/...) or directory.
48     -r|--release <release>      Specify release of new Debian system. Supported relases: sarge, etch, lenny and sid.
49     -m|--mirror <URL>           Specify mirror which should be used for apt-get/aptitude.
50     -i|--iso <mnt>              Specify mountpoint where Debian ISO is mounted to (instead of using mirror)
51     -p|--mntpoint <mnt>         Specify mountpoint that should be used for mounting the target system.
52     --groot <device>            Specify root device for usage in grub (corresponds with \$TARGET).
53     --grub <device>             Where do you want to install grub to? Use grub syntax for specifying.
54     --password <pwd>            Use specified password as password for user root. Use with caution.
55     --boot_append <appendline>  Add specified appendline to kernel whilst booting
56
57 "
58 }
59
60 while [ "$#" -gt "0" ] ; do
61     case $1 in
62         -v|--version)
63             einfo "$0 - version $VERSION"
64             einfo "Send bug reports to Michael Prokop <mika@grml.org>."
65             eend 0
66             exit 0
67             ;;
68         -t|--target)
69             shift
70             TARGET=$1
71             ;;
72         --grub)
73             shift
74             GRUB=$1
75             ;;
76         --groot)
77             shift
78             GROOT=$1
79             ;;
80         --release)
81             shift
82             RELEASE=$1
83             ;;
84         -p|--mntpoint)
85             shift
86             MNTPOINT=$1
87             ;;
88         --password)
89             shift
90             ROOTPASSWORD=$1
91             ;;
92         -m|--mirror)
93             shift
94             MIRROR=$1
95             CHROOTMIRROR=$1
96             ;;
97         -i|--iso)
98             shift
99             [ -n "$MIRROR"] && unset MIRROR
100             ISO=$1
101             ;;
102         -h|--help)
103             usage ; eend 0
104             eend 0
105             exit 0
106             ;;
107         *)
108             eerror "Syntax error."
109             usage ; eend 1
110             exit 1
111             ;;
112     esac
113     shift
114 done
115 # }}}
116
117 # set/check variables {{{
118
119 # inside the chroot system the locales might not be available, so use minimum:
120 export LANG=C
121 export LC_ALL=C
122
123 if [ -z "$STAGES" ] ; then
124    STAGES='/etc/debootstrap/stages'
125    [ -d "$STAGES" ] || mkdir -p "$STAGES"
126 fi
127
128 if [ -r $STAGES/grml-debootstrap ] ; then
129    if grep -q done $STAGES/grml-debootstrap ; then
130       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
131       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}" ; eend 1
132    fi
133 fi
134
135 PARTITION=''
136 DIRECTORY=''
137
138 case $TARGET in
139   /dev/*)
140     PARTITION=1
141     ;;
142   *)
143     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
144     DIRECTORY=1
145     MNTPOINT="$TARGET"
146     MKFS=''
147     TUNE2FS=''
148     FSCK=''
149     GRUB=''
150     GROOT=''
151     ;;
152 esac
153
154 if [ -n "$ARCH" ] ; then
155    ARCHCMD="--arch $ARCH"
156    ARCHINFO=" (${ARCH})"
157 else
158    ARCH="$(dpkg --print-architecture)"
159    ARCHCMD="--arch $ARCH"
160    ARCHINFO=" (${ARCH})"
161 fi
162
163 # make sure we have the right syntax when using an iso image
164 case $ISO in
165    file*) # do nothing
166     ;
167    *)
168     ISO=file:$1
169     ;;
170 esac
171
172 # provide variables to chroot system
173 touch /etc/debootstrap/variables
174 chmod 600 /etc/debootstrap/variables # make sure nobody except root can read it
175 [ -n "$ARCH" ]   && echo "ARCH=$ARCH"     >  /etc/debootstrap/variables
176 [ -n "$GRUB" ]   && echo "GRUB=$GRUB"     >> /etc/debootstrap/variables
177 [ -n "$GROOT" ]  && echo "GROOT=$GROOT"   >> /etc/debootstrap/variables
178 [ -n "$TARGET" ] && echo "TARGET=$TARGET" >> /etc/debootstrap/variables
179 [ -n "$ISO" ]    && echo "ISO=$ISO"       >> /etc/debootstrap/variables
180 [ -n "$MIRROR" ] && echo "MIRROR=$MIRROR" >> /etc/debootstrap/variables
181 [ -n "$MIRROR" ] && echo "CHROOTMIRROR=$MIRROR" >> /etc/debootstrap/variables
182 [ -n "$ROOTPASSWORD" ] && echo "ROOTPASSWORD=$ROOTPASSWORD" >> /etc/debootstrap/variables
183
184 # make sure at least $TARGET is set [the partition for the new system]
185 if [ -z "$TARGET" ] ; then
186    eerror "Please adjust /etc/debootstrap/config before running ${0}" ; eend 1
187    exit 1
188 fi
189 # }}}
190
191 # helper functions {{{
192 # we want to exit smoothly and clean:
193 bailout(){
194   # make sure $TARGET is not mounted when exiting grml-debootstrap
195   if [ -n "$MNTPOINT" ] ; then
196      if grep -q $MNTPOINT /proc/mounts ; then
197         # make sure nothing is left inside chroot so we can unmount it
198         [ -x "$MNTPOINT"/etc/init.d/ssh   ] && "$MNTPOINT"/etc/init.d/ssh stop
199         [ -x "$MNTPOINT"/etc/init.d/mdadm ] && "$MNTPOINT"/etc/init.d/mdadm stop
200         # ugly, but make sure we really don't leav anything
201         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /sys  1>/dev/null 2>&1
202         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a    1>/dev/null 2>&1
203         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
204         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount /proc 1>/dev/null 2>&1
205         [ -d "$TARGET/$ISO" ] && umount "$TARGET/$ISO"
206         einfo "Unmounting $MNTPOINT" ; umount "$MNTPOINT" ; eend $?
207      fi
208   fi
209   [ -n "$1" ] && EXIT="$1" || EXIT="1"
210   [ -n "$3" ] && einfo "Notice: just remove $STAGES/$3 to reexecute the stage"
211   exit "$EXIT"
212 }
213 trap bailout 1 2 3 15
214
215 # we want to execute all the functions only once, simple check for it:
216 stage() {
217   if [ -n "$2" ] ; then
218      echo "$2" > "$STAGES/$1"
219      return 0
220   elif grep -q done "$STAGES/$1" 2>/dev/null ; then
221      ewarn "Notice: stage $1 has been executed already, skipping execution therefore." ; eend 0
222      return 1
223   fi
224 }
225 # }}}
226
227 # user should recheck his configuration {{{
228 # support full automatic installation:
229 checkforrun() {
230    dialog --timeout 10 --title "$0" \
231           --yesno "Do you want to stop at this stage?
232
233 Notice: you are running grml-debootstrap in non-interactive mode.
234 grml-debootstrap will install Debian ${RELEASE} on ${TARGET}.
235 Last chance to quit. Timeout of 10 seconds running....
236
237 Do you want to stop now?" 0 0 2>/dev/null
238 }
239
240 if [ -n "$AUTOINSTALL" ] ; then
241    if checkforrun ; then
242       eerror "Exiting as requested" ; eend 0
243       exit 1
244    fi
245 else # if not running automatic installation display configuration and prompt for execution:
246    einfo "$0 - Please recheck configuration before execution:"
247    echo
248    echo "   Target:           $TARGET"
249       case "$MNTPOINT" in "$TARGET") ;; *) echo "   Mount-point:      $MNTPOINT" ;; esac
250       [ -n "$GRUB" ]   && echo "   Install grub to:  $GROOT / $GRUB"
251       [ -n "$MIRROR" ] && echo "   Using mirror:     $MIRROR"
252       [ -n "$ISO" ] && echo "   Using iso:        $ISO"
253       case "$MNTPOINT" in "$TARGET") ;; *) echo "   Important! Continuing will delete all data from ${TARGET}!" ;; esac
254       echo
255    einfon "Is this ok for you? [y/N] "
256    read a
257    if ! [ "$a" = 'y' -o "$a" = 'Y' ] ; then
258       eerror "Exiting as requested." ; eend 1
259       exit 1
260    fi
261 fi
262 # }}}
263
264 # create filesystem {{{
265 mkfs() {
266   if [ -n "$MKFS" ] ; then
267      einfo "Running $MKFS on $TARGET"
268      $MKFS $TARGET
269      eend $?
270   fi
271 }
272 # }}}
273
274 # modify filesystem settings {{{
275 tunefs() {
276   if [ -n "$TUNE2FS" ] ; then
277      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
278      $TUNE2FS $TARGET
279      eend $?
280   fi
281 }
282 # }}}
283
284 # mount the new partition or if it's a directory do nothing at all {{{
285 mount_target() {
286   if [ -n "$DIRECTORY" ] ; then
287      einfo "Running grml-debootstrap on a directory, nothing to mount."
288   else
289      if grep -q $TARGET /proc/mounts ; then
290         eerror "$TARGET already mounted, exiting."
291      else
292        [ -n "$MNTPOINT" ] || MNTPOINT='/mnt/test'
293        [ -d "$MNTPOINT" ] || mkdir -p "$MNTPOINT"
294        einfo "Mounting $TARGET to $MNTPOINT"
295        mount -o rw,suid,dev $TARGET $MNTPOINT
296        eend $?
297      fi
298   fi
299   if [ -n "$ISO" ] ; then
300      mkdir "$TARGET/$ISO"
301      mount --bind "$ISO" "$TARGET/$ISO"
302   fi
303 }
304 # }}}
305
306 # install main chroot {{{
307 debootstrap_system() {
308   if ! grep -q $MNTPOINT /proc/mounts ; then
309           mount_target
310   fi
311   if grep -q $MNTPOINT /proc/mounts ; then
312      einfo "Running $DEBOOTSTRAP for release ${RELEASE}${ARCHINFO} using ${MIRROR}${ISO}"
313      [ -n "$MIRROR" ] && $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $MIRROR || \
314      $DEBOOTSTRAP $ARCHCMD $RELEASE $MNTPOINT $ISO
315      eend $?
316   else
317      eerror "Error: $MNTPOINT not mounted, can not continue."
318      eend 1
319   fi
320 }
321 # }}}
322
323 # prepare chroot via chroot-script {{{
324 preparechroot() {
325   einfo "Preparing chroot system"
326   cp $CONFFILES/chroot-script $MNTPOINT/bin/chroot-script
327   chmod 755 $MNTPOINT/bin/chroot-script
328   mkdir $MNTPOINT/etc/debootstrap/
329
330   # make sure we have our files for later use via chroot-script
331   cp /etc/debootstrap/config          $MNTPOINT/etc/debootstrap/
332   cp /etc/debootstrap/packages        $MNTPOINT/etc/debootstrap/packages
333   cp /etc/debootstrap/variables       $MNTPOINT/etc/debootstrap/variables
334
335   cp -a /etc/debootstrap/extrapackages/ $MNTPOINT/etc/debootstrap/
336
337   # make sure we can access network [relevant for cdebootstrap]
338   [ -f "$MNTPOINT/etc/resolv.conf" ] || cp /etc/resolv.conf $MNTPOINT/etc/resolv.conf
339
340   # setup default locales
341   [ -n "$LOCALES" ] && cp /etc/debootstrap/locale.gen  $MNTPOINT/etc/locale.gen
342
343   # copy any existing existing files to chroot
344   [ -d /etc/debootstrap/boot  ] && cp -a /etc/debootstrap/boot/*  $MNTPOINT/boot/
345   [ -d /etc/debootstrap/etc   ] && cp -a /etc/debootstrap/etc/*   $MNTPOINT/etc/
346   [ -d /etc/debootstrap/share ] && cp -a /etc/debootstrap/share/* $MNTPOINT/share/
347   [ -d /etc/debootstrap/usr   ] && cp -a /etc/debootstrap/usr/*   $MNTPOINT/usr/
348   [ -d /etc/debootstrap/var   ] && cp -a /etc/debootstrap/var/*   $MNTPOINT/var/
349   eend 0
350 }
351 # }}}
352
353 # execute chroot-script {{{
354 chrootscript() {
355   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
356      mount_target
357   fi
358   if [ -x "$MNTPOINT/bin/chroot-script" ] ; then
359      einfo "Executing chroot-script now"
360      chroot "$MNTPOINT" /bin/chroot-script
361      eend $?
362   else
363      eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
364      eend 1
365   fi
366 }
367 # }}}
368
369 # install booloader grub {{{
370 grub_install() {
371   if [ -z "$GRUB" -o -z "$GROOT" ] ; then
372      echo "Notice: \$GRUB or \$GROOT not defined, will not install grub therefor."
373   else
374      einfo "Installing grub on ${GRUB}:"
375      [ -x /usr/sbin/grub-install ] && GRUBINSTALL=/usr/sbin/grub-install || GRUBINSTALL=/sbin/grub-install
376      $GRUBINSTALL --root-directory="$MNTPOINT" "(${GRUB})"
377      eend $?
378   fi
379 }
380 # }}}
381
382 # unmount $MNTPOINRT {{{
383 umount_chroot() {
384   if [ -n "$PARTITION" ] ; then
385      einfo "Unmount $MNTPOINT"
386      umount $MNTPOINT
387      eend $?
388   fi
389 }
390 # }}}
391
392 # execute filesystem check {{{
393 fscktool() {
394   if [ "$FSCK" = 'yes' ] ; then
395      [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
396      einfo "Checking filesystem on $TARGET using $FSCKTOOL"
397      $FSCKTOOL $TARGET
398      eend $?
399   fi
400 }
401 # }}}
402
403 # now execute all the functions {{{
404 for i in mkfs tunefs mount_target debootstrap_system preparechroot \
405          chrootscript grub_install umount_chroot fscktool ; do
406     if stage $i ; then
407        $i && stage $i done || bailout 2 "i"
408     fi
409 done
410 # }}}
411
412 # stages {{{
413   echo done > $STAGES/grml-debootstrap
414 # }}}
415
416 if [ -n "$AUTOINSTALL" ] ; then
417    dialog --title "$0" --msgbox \
418           "Finished execution of ${0}.
419 Enjoy your Debian system." 6 60
420 else
421    einfo "Finished execution of $0 - enjoy your Debian system." ; eend 0
422 fi
423
424 ## END OF FILE #################################################################
425 # vim: ai tw=100 expandtab foldmethod=marker